#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

string to_string(__int128 x) {
    return to_string((int64_t) x);
}

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif

#define int __int128

//int abs(int x) {
//    if (x < 0) {
//        return -x;
//    }
//    return x;
//}

template<typename T>
T extgcd(T a, T b, T &x, T &y) {
    if (a == 0) {
        x = 0;
        y = 1;
        return b;
    }
    T p = b / a;
    T g = extgcd(b - p * a, a, y, x);
    x -= p * y;
    return g;
}

template<typename T>
bool diophantine(T a, T b, T c, T &x, T &y, T &g) {
    if (a == 0) {
        if (c % b == 0) {
            x = 0;
            y = c / b;
            g = abs(b);
            return true;
        }
        return false;
    }
    g = extgcd(a, b, x, y);
    if (c % g != 0) {
        return false;
    }
    T dx = c / a;
    c -= dx * a;
    T dy = c / b;
    c -= dy * b;
    x = dx + (T) ((__int128) x * (c / g) % b);
    y = dy + (T) ((__int128) y * (c / g) % a);
    g = abs(g);
    return true;
}

const int K = 21;

void solve() {
    int64_t kok;
    cin >> kok;
    int s = kok;
    vector<int> deg(K), cnt(K);
    deg[0] = 1;
    for (int i = 1; i < K; i++) {
        deg[i] = deg[i - 1] * 10;
        cnt[i] = deg[i] - deg[i - 1];
    }
    cnt[1] = 10;
    int res = -1;
    int64_t l = -1, r = -1;
    for (int fl = 1; fl < K; fl++) {
        for (int fr = max(fl - 1, (__int128) 1); fr < K; fr++) {
            int cur = 0, vals = 0;
            for (int i = fl; i <= fr; i++) {
                cur += cnt[i] * i;
                vals += cnt[i];
            }
            if (cur > s) {
                continue;
            }
            int a = fl - 1;
            int b = fr + 1;
            int c = s - cur;
            int x, y, g;
            if (diophantine(a, b, c, x, y, g)) {
                int cntLeft = cnt[a];
                int cntRight = cnt[b];
                c /= g;
                b /= g;
                a /= g;
                int kLeft = max((cntRight - y) / (-a), -x / b);
                int kRight = min((cntLeft - x) / b, -(y / a));
                while (x + kLeft * b < 0) {
                    kLeft++;
                }
                while (y - kLeft * a > cntRight) {
                    kLeft++;
                }
                while (x + kRight * b > cntLeft) {
                    kRight--;
                }
                while (y - kRight * a < 0) {
                    kRight--;
                }
                int first = (fl <= 1 ? 0 : deg[fl - 1]);
                int last = deg[fr] - 1;
//                debug(a, b, c, kLeft, kRight);
                if (kLeft <= kRight) {
//                    debug(x + kRight * b);
//                    debug(y - kRight * a);
                    int v1 = vals + x + y + kLeft * (b - a);
                    int v2 = vals + x + y + kRight * (b - a);
                    if (v1 > res) {
                        res = v1;
                        int xx = x + kLeft * b;
                        int yy = y - kLeft * a;
                        l = first - xx;
                        r = last + yy;
//                        debug(res, fl, fr, l, r);
                    }
                    if (v2 > res) {
                        res = v2;
                        int xx = x + kRight * b;
                        int yy = y - kRight * a;
                        l = first - xx;
                        r = last + yy;
                    }
                }
            }
        }
    }

    for (int i = 1; i < K; i++) {
        if (s % i == 0 && s / i <= cnt[i]) {
            if (s / i > res) {
                res = s / i;
                l = (i == 1 ? 0 : deg[i - 1]);
                r = l + s / i - 1;
            }
        }
    }

    int64_t bebra = res;
    if (bebra == -1) {
        cout << -1;
    } else {
        cout << bebra << '\n';
        cout << l << ' ' << r;
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}
