#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <array>

using namespace std;

typedef long long ll;

set<int>diag = { 2, 4, 6, 8 };
int n, m;
pair<int, int> get_anom(int x, int y, vector<vector<int>>& arr) {
	vector<vector<int>>corr(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (i == x && j == y)
				continue;
			int dx = i - x, dy = j - y;
			if (abs(dx) == abs(dy)) {
				if (dx > 0 && dy > 0)
					corr[i][j] = 8;
				else if (dx > 0 && dy < 0)
					corr[i][j] = 2;
				else if (dx < 0 && dy > 0)
					corr[i][j] = 6;
				else
					corr[i][j] = 4;
			}
			else {
				if (abs(dx) < abs(dy)) {
					if (y < j)
						corr[i][j] = 7;
					else
						corr[i][j] = 3;
				}
				else {
					if (x < i)
						corr[i][j] = 1;
					else
						corr[i][j] = 5;
				}
			}
		}
	}
	vector<int>row(n), col(m);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (i == x && j == y)
				continue;
			if (corr[i][j] != arr[i][j])
				row[i]++, col[j]++;
		}
	}
	int cnt_row = 0, cnt_col = 0;
	for (int i = 0; i < n; i++)
		if (row[i] > 1)
			cnt_row++;
	for (int j = 0; j < m; j++)
		if (col[j] > 1)
			cnt_col++;
	int mx_row = *max_element(row.begin(), row.end()), mx_col = *max_element(col.begin(), col.end());
	int a = -1, b = -1;
	for (int i = 0; i < n; i++)
		if (row[i] == mx_row)
			a = i;
	for (int j = 0; j < m; j++) {
		if (col[j] == mx_col)
			b = j;
	}
	if (cnt_row > 1 || cnt_col > 1 || (row[a] != m - (y== b)) || (col[b] != n - (x == a)))
		return { -1, -1 };
	return { a, b };
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	
	cin >> n >> m;
	vector<vector<int>>arr(n, vector<int>(m));
	for (auto& i : arr)
		for (auto& k : i)
			cin >> k;
	vector<pair<int, int>>mag;
	for (int j = 0; j < m; j++) {
		vector<int>ind;
		for (int i = 0; i < n; i++) {
			if (diag.find(arr[i][j]) != diag.end())
				ind.push_back(i);
		}
		if (ind.size() == 2) {
			mag.push_back({ (ind[0] + ind[1]) / 2,-1 });
			int delta = (ind[1] - ind[0]) / 2;
			if (j + 1 >= m || ind[1] + 1 >= n || diag.find(arr[ind[1] + 1][j + 1]) == diag.end())
				mag.back().second = j - delta;
			else
				mag.back().second = j + delta;
		}
	}
	if (mag.empty()){
		for (int i = 0; i<n; i++) {
			vector<int>ind;
			for (int j = 0; j < m; j++) {
				if (diag.find(arr[i][j]) != diag.end())
					ind.push_back(j);
			}
			if (ind.size() == 2) {
				mag.push_back({ -1,  (ind[0] + ind[1]) / 2 });
				int delta = (ind[1] - ind[0]) / 2;
				if (i + 1 >= n || ind[1] + 1 >= m || diag.find(arr[i + 1][ind[1] + 1]) == diag.end())
					mag.back().first = i + delta;
				else
					mag.back().first = i - delta;
			}
		}
		if (mag.empty()) {
			// 0 0 
			int w = 0, cnt = 0, i = 1, j = 1;
			for (; i < n && j < m; i++, j++) {
				w++;
				cnt += (arr[i][j] == 8 || arr[i][j] == 4);
			}
			if (w == cnt) {
				mag.push_back({ 0, 0 });
			}
			else {
				// 0 m - 1
				w = 0, cnt = 0, i = 1, j = m - 2;
				for (; i < n && j >= 0; i++, j--) {
					w++;
					cnt += (arr[i][j] == 2 || arr[i][j] == 6);
				}
				if (w == cnt) {
					mag.push_back({ 0, m - 1 });
				}
				else {
					// n-1 0
					w = 0, cnt = 0, i = n - 2, j = 1;
					for (; i >= 0 && j < m; j++, i--) {
						w++;
						cnt += (arr[i][j] == 2 || arr[i][j] == 6);
					}
					if (w == cnt) {
						mag.push_back({ n - 1, 0 });
					}
					else {
						// n-1 m-1
						w = 0, cnt = 0, i = n - 2, j = m - 2;
						for (; i >= 0 && j >= 0; j--, i--) {
							w++;
							cnt += (arr[i][j] == 8 || arr[i][j] == 4);
						}
						if (w == cnt) {
							mag.push_back({ n - 1, m - 1 });
						}
					}
				}
			}
		}
	}
	for (auto p : mag) {
		pair<int, int>a = get_anom(p.first, p.second, arr);
		if (a.first != -1) {
			cout << p.first + 1 << ' ' << p.second + 1 << '\n' << a.first + 1 << ' ' << a.second + 1;
			return 0;
		}
	}
	return 0;
}