#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <array>
#include <tuple>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = 1e15;
constexpr ld EPS = 1e-9L;

mt19937 rnd(0);

ll C;

struct node {
    node* left = nullptr;
    node* right = nullptr;
    ll color = -1;
    ll up = -1;

    node() = default;
    node(ll color) :color(color), up(color) {}
    
    void newColor(ll new_color) {
        color = new_color;
        up = new_color;
    }

    void push() {
        if (left == nullptr)
            left = new node();
        if (right == nullptr)
            right = new node();

        if (up == -1) return;
        
        left->newColor((up + 1) % C);
        right->newColor((up + C - 1) % C);
        up = -1;
    }
};



void write(node* root, const string& s, ll new_color) {
    for (ll i = 0; i < s.size(); ++i) {
        root->push();
        if (s[i] == 'L')
            root = root->left;
        else
            root = root->right;
    }
    root->newColor(new_color);
}

ll read(node* root, const string& s) {
    for (ll i = 0; i < s.size(); ++i) {
        root->push();
        if (s[i] == 'L')
            root = root->left;
        else
            root = root->right;
    }
    return root->color;
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    node root;
    ll q;
    cin >> q >> C;
    while (q--) {
        ll t;
        string s;
        cin >> t;
        if (t == 1) {
            ll x;
            cin >> x >> s;
            write(&root, s, x);
        }
        else {
            cin >> s;
            //cerr << ">>> ";
            cout << read(&root, s) << '\n';
        }
    }
}