#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <array>
#include <tuple>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = 1e15;
constexpr ld EPS = 1e-9L;

mt19937 rnd(0);

struct Node {
    int l, r;
    int ans;
};

vector<int> a;
vector<Node> t;

void build(int ind, int l, int r) {
    t[ind].l = l;
    t[ind].r = r;
    if (l == r) {
        t[ind].ans = a[l];
        return;
    }
    int m = (l + r) / 2;
    build(ind * 2 + 1, l, m);
    build(ind * 2 + 2, m + 1, r);
    t[ind].ans = min(t[ind * 2 + 1].ans, t[ind * 2 + 2].ans);
}

int get(int ind, int l, int r) {
    if (l > t[ind].r || r < t[ind].l) {
        return 1e9 + 1;
    }
    if (l <= t[ind].l && t[ind].r <= r) {
        return t[ind].ans;
    }
    int res1 = get(ind * 2 + 1, l, r);
    int res2 = get(ind * 2 + 2, l, r);
    return min(res1, res2);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;
    a.resize(n);
    t.resize(4 * n);
    ll s = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        s += a[i];
    }
    build(0, 0, n - 1);
    s++;
    s /= 2;
    vector<ll> p(n + 1);
    for (int i = 0; i < n; ++i) {
        p[i + 1] += p[i] + a[i];
    }
    int l = 0, r = 0;
    int ans = 1e9;
    while (r <= n) {
        while (r <= n) {
            ll x = p[r] - p[l];
            if (x >= s) {
                ans = min(ans, r - l);
                if (r < n) {
                    ll x1 = p[r + 1] - p[l];
                    ll y = get(0, l + 1, r);
                    if (x1 - y >= s) {
                        ans = min(ans, r - l - 1);
                    }
                    r++;
                    break;
                }
                r++;
                break;
            }
            r++;
        }
        l++;
    }
    cout << ans;
}