#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <array>
#include <tuple>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = 1e15;
constexpr ld EPS = 1e-9L;

mt19937 rnd(0);

struct Node {
    ll l, r;
    ll ans;
};

vector<ll> a;
vector<Node> t;

void build(ll ind, ll l, ll r) {
    t[ind].l = l;
    t[ind].r = r;
    if (l == r) {
        t[ind].ans = a[l];
        return;
    }
    ll m = (l + r) / 2;
    build(ind * 2 + 1, l, m);
    build(ind * 2 + 2, m + 1, r);
    t[ind].ans = min(t[ind * 2 + 1].ans, t[ind * 2 + 2].ans);
}

ll get(ll ind, ll l, ll r) {
    if (l > t[ind].r || r < t[ind].l) {
        return 1e9 + 1;
    }
    if (l <= t[ind].l && t[ind].r <= r) {
        return t[ind].ans;
    }
    ll res1 = get(ind * 2 + 1, l, r);
    ll res2 = get(ind * 2 + 2, l, r);
    return min(res1, res2);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n;
    cin >> n;
    a.resize(n);
    t.resize(4 * n);
    ll s = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        s += a[i];
    }
    build(0, 0, n - 1);
    s++;
    s /= 2;
    int l = 0, r = 0;
    ll sm = 0;
    int ans = 1e6;
    while (true)
    {
        if (r == n && l == n - 1)
            break;
        if (r == n) {
            sm -= a[l++];
        }
        else if (r < n && sm < s) {
            sm += a[r++];
        }
        else {
            sm -= a[l++];
        }
        if (sm >= s) {
            ans = min(ans, r - l);
        }
        if (sm - get(0, l, r-1) >= s) {
            ans = min(ans, r - l - 1);
        }
    }
    cout << ans;
}