#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <array>
#include <tuple>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = 1e15;
constexpr ld EPS = 1e-9L;

mt19937 rnd(0);


int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    ll n;
    string s;
    cin >> n >> s;

    vector<ll> a(n + 1);
    a[0] = 1;
    a[1] = a.size();
    for (ll i = 2; i < a.size(); i += 2) {
        a[i] = a[i - 2] + 1;
    }
    for (ll i = 3; i < a.size(); i += 2) {
        a[i] = a[i - 2] - 1;
    }

    ll red = 0;
    ll blue = 0;

    vector<pair<ll, ll>> v;
    ll len = 0;

    for (ll i = 0; i < n; ++i) {
        if (s[i] == 'A') {
            ++len;

            if (a[i] < a[i + 1])
                ++red;
            else
                ++blue;

        }
        else {
            if (len % 2 == 1) {
                v.emplace_back(i - len, len);
            }
            len = 0;
        }
    }

    for (auto& [t, len] : v) {
        if (a[t] < a[t + 1] && red > blue) {
            reverse(a.begin() + t, a.begin() + t + len + 1);
            --red;
            ++blue;
        }

        if (a[t] > a[t + 1] && red < blue) {
            reverse(a.begin() + t, a.begin() + t + len + 1);
            ++red;
            --blue;
        }
    }

    for (auto& t : a)
        cout << t << ' ';
}