﻿#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <array>
#include <tuple>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = 1e15;
constexpr ld EPS = 1e-9L;

mt19937 rnd(0);

ll f(ll x) {
    ll res = 0;
    for (ll i = 0; i < 64; ++i) {
        if ((x >> i) & 1)
            ++res;
    }
    return res;
}

ll g(ll x) {
    ll res = 1;
    for (; res <= x; res *= 2);
    return res;
}

ll dfs(ll x, ll cnt) {
    if (cnt > 40)
        return cnt;
    if (x == 0)
        return 0;

    ll res = f(x);
    ll a = g(x) - 1 - f(x);
    if (a < x)
        res = min(res, dfs(a, cnt + 2) + 2);
    
    a = g(x) - f(x);
    if (a < x)
        res = min(res, dfs(a, cnt + 1) + 1);

    return res;
}

struct Node {
    ll a, b;
    int ind;
};

bool cmp(Node a, Node b) {
    if (a.a * b.b > a.b * b.a) {
        return true;
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<Node> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].a >> a[i].b;
        a[i].ind = i;
    }
    sort(a.begin(), a.end(), cmp);
    for (auto x : a) {
        cout << x.ind + 1 << " ";
    }
}