﻿#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <array>
#include <tuple>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = 1e15;
constexpr ld EPS = 1e-9L;

mt19937 rnd(0);


//
//struct Node {
//    ll a, b;
//    int ind;
//};
//
//bool cmp(Node a, Node b) {
//    if (a.a * b.b > a.b * b.a) {
//        return true;
//    }
//    return false;
//}

struct pt {
    ll x, y;
    pt(ll x, ll y) : x(x), y(y) {}
};

ll len(pt a, pt b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

struct seg {
    pt a, b;
    seg(pt a, pt b) : a(a), b(b) {}
};

ll len(seg s) {
    return len(s.a, s.b);
}

bool check(seg A, seg B, seg l) {
    return (min(min(len(A.a, B.a), len(A.a, B.b)), min(len(A.b, B.a), len(A.b, B.b))) <= len(l));
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int n, x, y;
    cin >> n;
    vector<seg> s;
    for (int i = 0; i < n; i++) {
        cin >> x >> y;
        pt a(x, y);
        cin >> x >> y;
        pt b(x, y);
        s.push_back(seg(a, b));
    }
    ll cnt = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            for (int k = j + 1; k < n; k++) {
                if (check(s[i], s[j], s[k]) || check(s[i], s[k], s[j]) || check(s[j], s[k], s[i]))
                    cnt++;
            }
        }
    }
    cout << cnt;
}