#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#include <algorithm>
#include <unordered_set>
#include <set>
#include <queue>
#include <cmath>
#include <numeric>
#include <sstream>
#include <string>
#include <map>
#include <unordered_map>
#include <deque>
#include <iomanip>
#include <unordered_set>
#include <limits>
#include <list>
#include <bitset>
#include <random>
#include <cstring>
#include <cassert>
#include <chrono>
#include <array>

#define ff first
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define ss second
#define pb push_back
#define all(a) a.begin(), a.end()
typedef long long ll;
typedef long double ld;
using namespace std;
const int MOD = 1000000007;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return a < b ? a = b, true : false;
}

double GetTime() { return clock() / (double) CLOCKS_PER_SEC; }

/// Actual code starts here
const int N = 100005;

__int128 gcd(__int128 a, __int128 b) {
    return b == 0 ? a : gcd(b, a % b);
}

__int128 lcm(__int128 a, __int128 b) {
    return a / gcd(a, b) * b;
}

__int128 euclid(__int128 a, __int128 b, __int128 &x, __int128 &y) {
    if (!b) {
        return x = 1, y = 0, a;
    }
    __int128 d = euclid(b, a % b, y, x);
    return y -= (a / b) * x, d;
}

__int128 crt(__int128 a, __int128 m, __int128 b, __int128 n) {
    if (n > m) {
        swap(n, m);
        swap(a, b);
    }
    __int128 x, y, g = euclid(m, n, x, y);
    if ((a - b) % g != 0) {
        return -1;
    }
    x = (b - a) % n * x % n / g * m + a;
    return x < 0 ? x + m / g * n : x;
}

void solve_KTO(__int128 &t, vector<__int128> &x, vector<__int128> &m, int n) {
    __int128 cur_x = x[0];
    __int128 cur_m = m[0];
    for (int i = 1; i < n; ++i) {
        cur_x = crt(cur_x, cur_m, x[i], m[i]);
        cur_m = cur_m / gcd(cur_m, m[i]) * m[i];
        if (cur_x < 0) {
            return;
        }
    }
    if (t == -1 || t > cur_x) {
        t = cur_x;
    }
}

void print_128(__int128 x) {
    if (x == 0) {
        cout << 0 << '\n';
        return;
    }
    if (x == -1) {
        cout << -1;
        return;
    }
    string res;
    while (x > 0) {
        res.pb('0' + x % 10);
        x /= 10;
    }
    reverse(all(res));
    cout << res;
}

void solve() {
    int n;
    cin >> n;
    int x1, y1, x2, y2;
    cin >> x1 >> y1 >> x2 >> y2;
    int X, Y;
    cin >> X >> Y;
    vector<int> x(n), y(n);
    vector<__int128> l(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
        l[i] = 2 * (x2 - x1 + 1) + 2 * (y2 - y1 + 1) + 4 + 8 * i;
    }

    vector<vector<int> > dist(200, vector<int>(200, (int) 1e9 + 7));
    vector<vector<pair<int, int> > > nxt(200, vector<pair<int, int> >(200));
    queue<pair<int, int> > q;
    for (int i = 0; i < n; ++i) {
        q.push({x[i], y[i]});
        dist[x[i]][y[i]] = 0;
        int left_x = x1 - 1 - i;
        int right_x = x2 + 1 + i;
        int left_y = y1 - 1 - i;
        int right_y = y2 + 1 + i;
        for (int j = left_y; j < right_y; ++j) {
            nxt[left_x][j + 1] = {left_x, j};
            nxt[right_x][j] = {right_x, j + 1};
        }
        for (int j = left_x; j < right_x; ++j) {
            nxt[j][left_y] = {j + 1, left_y};
            nxt[j + 1][right_y] = {j, right_y};
        }
    }
    while (!q.empty()) {
        int vx = q.front().ff;
        int vy = q.front().ss;
        q.pop();
        int ux = nxt[vx][vy].ff;
        int uy = nxt[vx][vy].ss;
        if (dist[ux][uy] > dist[vx][vy] + 1) {
            dist[ux][uy] = dist[vx][vy] + 1;
            q.push({ux, uy});
        }
    }
    /**for (int i = 1; i <= 7; ++i) {
        for (int j = 1; j <= 7; ++j) {
            cout << dist[i][j] << ' ';
        }
        cout << '\n';
    }**/
    __int128 t = -1;
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<__int128> val(n);
        for (int i = 0; i < n; ++i) {
            int py = Y;
            int px = x1 - 1 - i;
            if (mask & (1 << i)) {
                py = Y;
                px = x2 + 1 + i;
            }
            val[i] = dist[px][py];
        }
        solve_KTO(t, val, l, n);
    }
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<__int128> val(n);
        for (int i = 0; i < n; ++i) {
            int py = y1 - 1 - i;
            int px = X;
            if (mask & (1 << i)) {
                py = y2 + 1 + i;
                px = X;
            }
            val[i] = dist[px][py];
        }
        solve_KTO(t, val, l, n);
    }
    print_128(t);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--)
        solve();
}
