#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#include <algorithm>
#include <unordered_set>
#include <set>
#include <queue>
#include <cmath>
#include <numeric>
#include <sstream>
#include <string>
#include <map>
#include <unordered_map>
#include <deque>
#include <iomanip>
#include <unordered_set>
#include <limits>
#include <list>
#include <bitset>
#include <random>
#include <cstring>
#include <cassert>
#include <chrono>
#include <array>

#define ff first
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define ss second
#define pb push_back
#define all(a) a.begin(),a.end()
typedef long long ll;
typedef long double ld;
using namespace std;
const int MOD = 1000000007;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return a < b ? a = b, true : false;
}

double GetTime() { return clock() / (double) CLOCKS_PER_SEC; };
const int N = 100005;

int sign(ll x) {
    if (x == 0) return 0;
    return (x < 0 ? -1 : 1);
}

ll sq(ll a) {
    return a * a;
}

#define vec point

struct point {
    ll x = 0, y = 0;


    point operator-(const point &other) const {
        return point({x - other.x, y - other.y});
    }


    bool operator==(const point &other) const {
        return sign(x - other.x) == 0 && sign(y - other.y) == 0;
    }

    ll operator*(const point &other) const {
        return x * other.x + y * other.y;
    }

    ll operator^(const point &other) const {
        return x * other.y - y * other.x;
    }

    ld len() const {
        return sqrtl(sq(x) + sq(y));
    }
};

bool on_segment(const point &a, const point &b, const point &c) {
    if (a == c || b == c) return true;
    if (a == b) return false;
    return sign((c - a) ^ (b - a)) == 0 && sign((c - a) * (b - a)) == 1 && sign((c - b) * (a - b)) == 1;
}

ld distance_point_segment(const point &a, const point &b, const point &c) {
    if (on_segment(a, b, c)) return 0;
    ld res = min(vec(c - a).len(), vec(c - b).len());
    if (sign((b - a) * (c - b)) <= 0 && sign((a - b) * (c - a)) <= 0)
        relaxmi(res, abs((b - a) ^ (c - b)) / (b - a).len());
    return res;
}

bool is_cross_segment_segment(const point &a, const point &b, const point &c, const point &d) {
    if (sign(min(max(a.x, b.x), max(c.x, d.x)) - max(min(a.x, b.x), min(c.x, d.x))) < 0) return false;
    if (sign(min(max(a.y, b.y), max(c.y, d.y)) - max(min(a.y, b.y), min(c.y, d.y))) < 0) return false;
    vec v1 = b - a, v2 = c - a, v3 = d - a;
    if (sign(v1 ^ v2) * sign(v1 ^ v3) == 1) return false;
    v1 = d - c, v2 = a - c, v3 = b - c;
    if (sign(v1 ^ v2) * sign(v1 ^ v3) == 1) return false;
    return true;
}


ld distance_segment_segment(const point &a, const point &b, const point &c, const point &d) {
    if (is_cross_segment_segment(a, b, c, d)) return 0;
    return min({distance_point_segment(a, b, c), distance_point_segment(a, b, d), distance_point_segment(c, d, a),
                distance_point_segment(c, d, b)});
}

void solve() {
    int n;
    cin >> n;
    vector<pair<point, point>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].ff.x >> v[i].ff.y >> v[i].ss.x >> v[i].ss.y;
    }
    int res = 0;
    for (int i = 0; i < n; i++)
        for (int j = i + 1; j < n; j++)
            for (int k = j + 1; k < n; k++) {
                bool ok = false;
                for (int l = 0; l < 3; l++) {
                    int mask = 7;
                    mask -= (1 << l);
                    vector<int> pt;
                    int id = -1;
                    for (int g = 0; g < 3; g++) {
                        if (mask & (1 << g)) {
                            if (g == 0) pt.pb(i);
                            else if (g == 1) pt.pb(j);
                            else pt.pb(k);
                        } else {
                            if (g == 0) id = i;
                            else if (g == 1) id = j;
                            else id = k;
                        }
                    }
                    int a = pt[0], b = pt.back();
                    ld dist = distance_segment_segment(v[a].ff, v[a].ss, v[b].ff, v[b].ss);
                    if (dist <= (v[id].ff - v[id].ss).len()) {
                        ok = true;
                    }
                }
                res += ok;
            }
    cout << res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--)
        solve();
}
