#include<bits/stdc++.h>
#define int long long
#define ibase ios_base::sync_with_stdio(0); cin.tie(0);
#define vec vector
#define all(x) x.begin(), x.end()
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define sz(x) (int)(x).size()
#define INF 1e18

using namespace std;
struct SegTree{
    vec<int> t;
    vec<int> a;

    SegTree (vec<int> &b)
    {
        a = b;
        t.resize(4 * sz(a));
    }
    void tree(int v, int vl, int vr)
    {
        if(vr == vl)
        {
            t[v] = a[vl];
            return;
        }
        int vm = vl + vr >> 1;
        tree(v * 2 + 1, vl, vm);
        tree(v * 2 + 2, vm + 1, vr);
        t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
    }

    int query(int v, int vl, int vr, int l, int r)
    {
        if(vl > r || vr < l)
            return INF;
        if(l <= vl && vr <= r)
            return t[v];

        int vm = vl + vr >> 1;
        return min(query(v * 2 + 1, vl, vm, l, r), query(v * 2 + 2, vm + 1, vr, l, r));
    }
};

signed main()
{
    ibase;

    int n;
    cin >> n;
    vec<int> a (n);
    for(auto &i : a)
        cin >> i;
    vec<int> pref;
    partial_sum(all(a), back_inserter(pref));
    SegTree T (a);
    T.tree(0, 0, n - 1);
    int sum = accumulate(all(a), (int)0);

    auto get = [&](int l, int r)
    {
        if(l)
            return pref[r] - pref[l - 1];
        return pref[r];
    };

    auto ch1 = [&](int l, int r)
    {
        if(get(l, r) * 2 >= sum)
        {
            return 1;
        }
        return 0;
    };

    auto ch2 = [&](int l, int r)
    {
        int mn = T.query(0, 0, n - 1, l, r);
        if((get(l, r) - mn) * 2 >= sum)
        {
            return 1;
        }
        return 0;
    };

    int ans = n + 1;

    FOR(i, n)
    {
        int l = i, r = n - 1;

        while(r - l > 1)
        {
            int mid = l + r >> 1;
            if(ch1(i, mid))
                r = mid;
            else
                l = mid;
        }

        if(ch1(i, l))
        {
            ans = min(ans, l - i + 1);
        }
        else if(ch1(i, r))
        {
            ans = min(ans, r - i + 1);
        }

        if(ch2(i, l))
        {
            ans = min(ans, l - i);
        }
        else if(ch2(i, r))
        {
            ans = min(ans, r - i);
        }
    }
    cout << ans << endl;
}

