#include <bits/stdc++.h>

#define all(a) a.begin(), a.end()
#define last(a) (a.end() - 1)

#pragma GCC optimize("O0")

using namespace std;

typedef long long ll;
typedef long double ld;

template<class T>
ostream& operator<<(ostream& os, vector<T> &a) {
	for (auto &i: a) {
		os << i << " ";
	}
	return os;
}

template<class T>
ostream& operator<<(ostream& os, vector<vector<T>> &a) {
	for (auto &i: a) {
		os << i << "\n";
	}
	return os;
}

template<class X, class Y>
ostream& operator<<(ostream& os, pair<X, Y> &a) {
	os << a.first << " " << a.second;
	return os;
}

// #define FILEI "input.txt"
// #define FILEO "output.txt"

struct cmp {
	bool operator()(pair<int, int> &a, pair<int, int> &b) {
		return a.first < b.first;
	}
};

int main() {
	#ifdef FILEI
		freopen(FILEI, "r", stdin);
	#else
		ios::sync_with_stdio(false);
		cin.tie(0);
	#endif
	#ifdef FILEO
		freopen(FILEO, "w", stdout);
	#else
		cout.tie(0);
	#endif
	int n;
	cin >> n;
	vector <ll> dp(n);
	vector<int> a(n);
	ll need = 0;

	for (int i = 0; i < n; i++) {
		cin >> a[i];
		need += a[i];
		if (i == 0) {
			dp[i] = a[i];
			continue;
		}
		dp[i] = dp[i - 1] + a[i];
	}

	need = ceil((float) need / 2);

	priority_queue<pair<int, int>, vector<pair<int, int>>, cmp> q;

	int l = 0, r = 0;
	long long sum = 0;
	int ans = 1e9;

	while (r < n) {
		q.emplace(a[r], r);
		
		while (q.top().second < l) {
			q.pop();
		}

		sum += a[r];

		if (sum >= need) {
			if (sum - q.top().first >= need) {
				ans = min(ans, r - l);
			} else {
				ans = min(ans, r - l + 1);
			}

			while (sum >= need && l + 1 <= r) {
				sum -= a[l++];
				while (q.top().second < l) {
					q.pop();
				}
				if (sum - q.top().first >= need) {
					ans = min(ans, r - l);
				} else {
					ans = min(ans, r - l + 1);
				}
			}
		}

		r++;
	}

	cout << ans;
	return 0;
}