#include <bits/stdc++.h>

#define all(a) a.begin(), a.end()
#define last(a) (a.end() - 1)

using namespace std;

typedef long long ll;
typedef long double ld;

template<class T>
ostream& operator<<(ostream& os, vector<T> &a) {
	for (auto &i: a) {
		os << i << " ";
	}
	return os;
}

template<class T>
ostream& operator<<(ostream& os, vector<vector<T>> &a) {
	for (auto &i: a) {
		os << i << "\n";
	}
	return os;
}

template<class X, class Y>
ostream& operator<<(ostream& os, pair<X, Y> &a) {
	os << a.first << " " << a.second;
	return os;
}

// #define FILEI "input.txt"
// #define FILEO "output.txt"

struct vertex {
	vertex *next[26] = {nullptr};
	int depth = 0, val = 0;
	bool isTreminal = false;
};

void add_str(string &s, vertex *v) {
	for (auto &c: s) {
		if (v->next[c - 'a'] == nullptr) {
			v->next[c - 'a'] = new vertex();
			v->next[c - 'a']->isTreminal = true;
			v->isTreminal = false;
		}
		v->next[c - 'a']->depth = v->depth + 1;
		v = v->next[c - 'a'];
		v->val++;
	}
}

int main() {
	#ifdef FILEI
		freopen(FILEI, "r", stdin);
	#else
		ios::sync_with_stdio(false);
		cin.tie(0);
	#endif
	#ifdef FILEO
		freopen(FILEO, "w", stdout);
	#else
		cout.tie(0);
	#endif

	int n;
	cin >> n;
	vector<string> words(n);
	for (auto &i: words) {
		cin >> i;
	}

	vertex *root = new vertex();

	root->val = n;

	for (auto &i: words) {
		add_str(i, root);
	}

	queue<vertex*> q;
	q.push(root);
	vertex* v;
	while (!q.empty()) {
		v = q.front();
		q.pop();
		if (v->val % 2) {
			cout << v->depth - 1;
			return 0;
		}

		for (int i = 0; i < 26; i++) {
			if (v->next[i]) {
				q.push(v->next[i]);
			}
		}
	}
	cout << v->depth;
	return 0;
}