#include <bits/stdc++.h>

using namespace std;

// clang-format off
#define int long long
#define eb emplace_back
#define ef emplace_front
#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define vi vector <int>
#define sz(a) (int)(a).size()
typedef long long ll;
typedef long double ld;
template<typename TYPE> using ve = vector<TYPE>;
// clang-format on
const ld EPS = 1e-9;
struct pt {
    int x, y;
};
int sign(ld x) {
    if (x > EPS) return 1;
    if (x < -EPS) return -1;
    return 0;
}
struct seq {
    int x1, y1, x2, y2;
    explicit seq(int a, int b, int c, int d) {
        x1 = a;
        y1 = b;
        x2 = c;
        y2 = d;
    }
};
istream &operator>>(istream &in, pt &a) {
    in >> a.x >> a.y;
    return in;
}

int operator *(pt &a, pt &b) {
    return a.x * b.x + a.y * b.y;
}

pt operator +(pt a, pt b) {
    return {a.x + b.x, a.y + b.y};
}

pt operator -(pt a, pt b) {
    return {a.x - b.x, a.y - b.y};
}
__int128 operator%(pt &a, pt &b) {
    __int128 res1 = a.x;
    res1 *= b.y;
    __int128 res2 = a.y;
    res2 *= b.x;
    return (__int128)(res1 - res2);
}


__int128 square_of_triangle(pt a, pt b, pt c) {
    return (__int128)(a % b + b % c + c % a);
}

bool intersect_1(int a, int b, int c, int d) {
    if (a > b) swap(a, b);
    if (c > d) swap(c, d);
    return max(a, c) <= min(b, d);
}

bool intersect(pt a, pt b, pt c, pt d) {
    if (intersect_1(a.x, b.x, c.x, d.x) and intersect_1(a.y, b.y, c.y, d.y)) {
        __int128 res1 = square_of_triangle(a, b, c);
        __int128 res2 = square_of_triangle(a, b, d);
        __int128 res3 = square_of_triangle(c, d, a);
        __int128 res4 = square_of_triangle(c, d, b);
        if (res1 == 0 or res2 == 0 or (res1 > 0 and res2 < 0) or(res1 < 0 and res2 > 0)) {
            if (res3 == 0 or res4 == 0 or (res3 > 0 and res4 < 0) or(res3 < 0 and res4 > 0)) {
                return true;
            }
            return false;
        }
        return false;
    }
    return false;
}

ld dist_pt_to_pt(pt a, pt c) {
    return hypotl(a.x - c.x, a.y - c.y);
}

ld dist_pt_to_sequence(pt a, seq cd) {
    int h = square_of_triangle(a, {cd.x1, cd.y1}, {cd.x2, cd.y2});
    pt CA = {a.x - cd.x1, a.y - cd.y1};
    pt CD = {cd.x2 - cd.x1, cd.y2 - cd.y1};
    pt DA = {a.x - cd.x2, a.y - cd.y2};
    pt DC = {cd.x1 - cd.x2, cd.y1 - cd.y2};
    if (CD * CA < 0) {
        return dist_pt_to_pt(a, {cd.x1, cd.y1});
    }
    if (DA * DC < 0) {
        return dist_pt_to_pt(a, {cd.x2, cd.y2});
    }
    return abs(h) / dist_pt_to_pt({cd.x1, cd.y1}, {cd.x2, cd.y2});
}


bool ray_interesect(seq ab, seq cd) {
    pt AB = {ab.x2 - ab.x1, ab.y2 - ab.y1};
    AB.x *= 1000000000;
    AB.y *= 1000000000;
    seq nab(ab.x1, ab.y1, ab.x1 + AB.x, ab.y1 + AB.y);
    pt CD = {cd.x2 - cd.x1, cd.y2 - cd.y1};
    CD.x *= 1000000000;
    CD.y *= 1000000000;
    seq ncd(cd.x1, cd.y1, cd.x1 + CD.x, cd.y1 + CD.y);
    return intersect({nab.x1, nab.y1}, {nab.x2, nab.y2}, {ncd.x1, ncd.y1}, {ncd.x2, ncd.y2});
}

ld dist_seq_seq(seq ab, seq cd) {
    pt a = {ab.x1, ab.y1};
    pt b = {ab.x2, ab.y2};
    pt c = {cd.x1, cd.y1};
    pt d = {cd.x2, cd.y2};
    seq ba(ab.x2, ab.y2, ab.x1, ab.y1);
    seq dc(cd.x2, cd.y2, cd.x1, cd.y1);
    if (ray_interesect(ab, cd) and ray_interesect(ba, cd) and ray_interesect(ab, dc) and ray_interesect(ba, dc)) {
        return 0;
    }
    return min({dist_pt_to_sequence(a, cd), dist_pt_to_sequence(b, cd), dist_pt_to_sequence(c, ab), dist_pt_to_sequence(d, ab)});
}
void solve() {
    int n;
    cin >> n;
    ve <pair <pt, pt>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            for (int k = j + 1; k < n; k++) {
                ve <pair <pt, pt>> b = {a[i], a[j], a[k]};
                bool flg = false;
                for (int x = 0; x < 3; x++) {
                    for (int y = x + 1; y < 3; y++) {
                        seq res1(b[x].first.x, b[x].first.y, b[x].second.x, b[x].second.y);
                        seq res2(b[y].first.x, b[y].first.y, b[y].second.x, b[y].second.y);
                        ld d = dist_seq_seq(res1, res2);
                        set <int> s = {0, 1, 2};;
                        s.erase(x);
                        s.erase(y);
                        int idx = *s.begin();
                        if (sign(dist_pt_to_pt(b[idx].second, b[idx].first) - d) >= 0) {
                            flg = true;
                        }
                    }
                }
                if (flg) {
                    ans++;
                }
            }
        }
    }
    cout << ans;
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    //    cin >> t;
    while (t--) solve();
    return 0;
}