﻿#include "bits/stdc++.h"
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#ifdef CLOWN

#include "trash.h"

#define dbg(...) cout << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__);
#else
#define dbg(...);
#endif

int test = 0;

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

#define ld long double
const ld eps = 1e-9;

struct pt {
    ld x, y;

    pt(ld x = 0, ld y = 0) : x(x), y(y) {}

    ld dist(pt b) {
        ld L = abs(b.x - x);
        ld R = abs(b.y - y);
        if (L < 1e9 && R < 1e9) {
            return sqrt(L * L + R * R);
        }
        ld X = max(L, R);
        L /= X;
        R /= X;
        ld D = sqrt(L * L + R * R);
        L /= D;
        R /= D;
        return abs(b.y - y) / R;
    }
};

class line {
public:
    ld a, b, c;

    void create(pt a1, pt b1) {
        a = b1.y - a1.y;
        b = a1.x - b1.x;
        c = -a * a1.x - b * a1.y;
    }

    ld dist_from_pt(pt b1) {
        return (abs(a * b1.x + b * b1.y + c)) / hypot(a, b);
    }
};

ld find(pt a, pt b, pt c) { // {a, b} - seg
    ld osn = hypotl(a.x - b.x, a.y - b.y);
    ld one = hypotl(a.x - c.x, a.y - c.y);
    ld two = hypotl(b.x - c.x, b.y - c.y);
    ld left_angle = one * one + osn * osn - two * two;
    ld right_angle = two * two + osn * osn - one * one;
    if (left_angle >= 0 && right_angle >= 0) {
        line d;
        d.create(a, b);
        return d.dist_from_pt(c);
    }
    return min(one, two);
}

ld f1(pt a, pt b, pt c) {
    return (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
}

int f(ld a, ld b, ld c, ld d) {
    if (a > b) swap(a, b);
    if (c > d) swap(c, d);
    return max(a, c) <= min(b, d);
}

int crossing_seg(pt a, pt b, pt c, pt d) {
    return f(a.x, b.x, c.x, d.x) && f(a.y, b.y, c.y, d.y) && f1(a, b, c) * f1(a, b, d) <= eps &&
           f1(c, d, a) * f1(c, d, b) <= eps;
}

void solve() {
    int n;
    cin >> n;
    vector<vector<pt>> a(n, vector<pt>(2));
    for (int i = 0; i < n; i++) cin >> a[i][0].x >> a[i][0].y >> a[i][1].x >> a[i][1].y;
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            for (int k = j + 1; k < n; k++) {
                vector<vector<pt>> b(3, vector<pt>(2));
                b[0] = a[i];
                b[1] = a[j];
                b[2] = a[k];
                int flag = 0;
                for (int change = 0; change < 3; change++) {
                    set<int> s;
                    s.insert({0, 1, 2});
                    s.erase(change);
                    int l = *s.begin();
                    int r = *s.rbegin();
                    ld maxdist = b[change][0].dist(b[change][1]);
                    ld mn = 2e18;
                    mn = min(mn, find(b[l][0], b[l][1], b[r][0]));
                    mn = min(mn, find(b[l][0], b[l][1], b[r][1]));
                    mn = min(mn, find(b[r][0], b[r][1], b[l][0]));
                    mn = min(mn, find(b[r][0], b[r][1], b[l][1]));
                    if (crossing_seg(b[l][0], b[l][1], b[r][0], b[r][1])) mn = 0;
                    dbg(change, maxdist, mn)
                    flag |= (maxdist >= mn);
                }
                ans += flag;
                if (flag) {
                    dbg(i, j, k)
                }
            }
        }
    }
    cout << ans << "\n";
}

int32_t main() {
#ifdef CLOWN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    fastio();
    if (test) cin >> t;
    while (t--) { solve(); }
    return 0;
}
