﻿#include <iostream>
#include <vector>

#pragma GCC optimaze("O3")
#pragma GCC optimaze("unroll-loops")
//#pragma GCC target("avx, abm")

using namespace std;

const int MAXN = 5e5 + 1;

int mtime = -1;

struct node {
    int ch[2];
    int tm, color;

    node() {
        ch[0] = ch[1] = -1;
        color = -1;
        tm = -1;
    }
};

node v[MAXN];
int sz = 1;

void color(const string& path, int x) {
    int u = 0, to;
    for (int c : path) {
        to = int(c == 'R');
        if (v[u].ch[to] == -1) {
            v[u].ch[to] = sz;
            ++sz;
        }
        u = v[u].ch[to];
    }
    ++mtime;
    v[u].tm = mtime;
    v[u].color = x;
}

int get(const string& path, int c) {
    int u = 0, to;
    int curtime = v[u].tm, curx = v[u].color;
    for (char chr : path) {
        to = int(chr == 'R');
        if (to) {
            curx = (curx + c - 1) % c;
        } else {
            curx = (curx + 1) % c;
        }
        if (v[u].ch[to] == -1) {
            v[u].ch[to] = sz;
            ++sz;
        }
        to = v[u].ch[to];

        if (v[to].tm > curtime) {
            curtime = v[to].tm;
            curx = v[to].color;
        }

        u = to;
    }
    return (curtime == -1) ? -1 : curx;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    string s;
    int q, c, x, t;
    cin >> q >> c;
    for (; q; --q) {
        cin >> t;
        if (t == 1) {
            cin >> x >> s;
            color(s, x);
        } else {
            cin >> s;
            cout << get(s, c) << '\n';
        }
    }
    return 0;
}
