﻿#include <iostream>
#include <vector>
#include <deque>

using namespace std;
using ll = long long;

ll mins;

ll get_sum(int l, int r, const vector<ll>& pref) {
    if (l) {
        return pref[r] - pref[l - 1];
    }
    return pref[r];
}

bool enough(int k, const vector<int>& a, const vector<ll>& pref) {
    int n = a.size();
    for (int i = k - 1; i < n; ++i) {
        if (get_sum(i - k + 1, i, pref) >= mins) {
            return true;
        }
    }

    deque<int> q;
    for (int i = 0; i < k; ++i) {
        while (!q.empty() && a[q.back()] >= a[i]) {
            q.pop_back();
        }
        q.push_back(i);
    }
    for (int i = k; i < n; ++i) {
        while (!q.empty() && a[q.back()] >= a[i]) {
            q.pop_back();
        }
        q.push_back(i);
        if (get_sum(i - k, i, pref) - a[q.front()] >= mins) {
            return true;
        }
        if (q.front() == i - k) {
            q.pop_front();
        }
    }
    return false;
}

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    vector<ll> pref(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    pref[0] = a[0];
    for (int i = 1; i < n; ++i) {
        pref[i] = pref[i - 1] + a[i];
    }
    mins = (pref[n - 1] + 1) / 2;

    int l = 0, r = n, mid;
    while (r - l > 1) {
        mid = (l + r) / 2;
        if (enough(mid, a, pref)) {
            r = mid;
        } else {
            l = mid;
        }
    }
    cout << r;

    return 0;
}
