#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <set>
#include <bitset>
#include <queue>
#include <stack>
#include <iomanip>
#include <fstream>
#include <ctime>
#include <random>
#include <cassert>

#define int long long
#define ld long double
#define fi first
#define se second
#define pii pair<int,int>
#define p_b push_back
#define m_p make_pair
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define sqr(x) ((x)*(x))
#define pw(x) (1LL << x)
#define sz(x) (int)x.size()

using namespace std;

const ld e = 1e-6;

int XA[105], YA[105], XB[105], YB[105];
ld mi[105][105];

ld dist(ld xa, ld ya, ld xb, ld yb)
{
    return sqrtl(sqr(xa - xb) + sqr(ya - yb));
}

ld get_y_by_x(ld xa, ld ya, ld xb, ld yb, ld x)
{
    return ya + (x - xa) * (yb - ya) / (xb - xa);
}

ld f(int i, ld x, ld y)
{
    ld l = min(XA[i], XB[i]);
    ld r = max(XA[i], XB[i]);
    while(r - l > e)
    {
        ld m1 = (l * 2 + r) / 3;
        ld m2 = (l + r * 2) / 3;
        if(dist(x, y, m1, get_y_by_x(XA[i], YA[i], XB[i], YB[i], m1)) <= dist(x, y, m2, get_y_by_x(XA[i], YA[i], XB[i], YB[i], m2)))
            r = m2;
        else
            l = m1;
    }
    return dist(x, y, l, get_y_by_x(XA[i], YA[i], XB[i], YB[i], l));
}

ld get_min(int i, int j)
{
    ld l = min(XA[i], XB[i]);
    ld r = max(XA[i], XB[i]);
    while(r - l > e)
    {
        ld m1 = (l * 2 + r) / 3;
        ld m2 = (l + r * 2) / 3;
        if(f(j, m1, get_y_by_x(XA[i], YA[i], XB[i], YB[i], m1)) <= f(j, m2, get_y_by_x(XA[i], YA[i], XB[i], YB[i], m2)))
            r = m2;
        else
            l = m1;
    }
    return f(j, l, get_y_by_x(XA[i], YA[i], XB[i], YB[i], l));
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for(int i = 0; i < n; i++)
        cin >> XA[i] >> YA[i] >> XB[i] >> YB[i];
    for(int i = 0; i < n; i++)
        for(int j = i + 1; j < n; j++)
            mi[i][j] = get_min(i, j);
    int ans = 0;
    for(int i = 0; i < n; i++)
        for(int j = i + 1; j < n; j++)
            for(int k = j + 1; k < n; k++)
                ans += (mi[i][j] <= dist(XA[k], YA[k], XB[k], YB[k]) + e || mi[i][k] <= dist(XA[j], YA[j], XB[j], YB[j]) + e || mi[j][k] <= dist(XA[i], YA[i], XB[i], YB[i]) + e);
    cout << ans;
    return 0;
}
