/// @author Camillus
#include <bits/stdc++.h>
#define x first
#define y second
#ifdef LOCAL
#   include "debug.h"
#else
#   define debug(...)
#endif
#define int long long
using namespace std;

using Vector = pair<int, int>;
using Point = Vector;

Vector operator-(Vector V) {
    return {-V.x, -V.y};
}

Vector operator+(Vector A, Vector B) { return {A.x + B.x, A.y + B.y}; }
Vector operator-(Vector A, Vector B) { return {A.x - B.x, A.y - B.y}; }

int operator%(Vector A, Vector B) { return A.x * B.y - A.y * B.x; }
int operator*(Vector A, Vector B) { return A.x * B.x + A.y * B.y; }

bool check(Vector A, Vector B) {
    return A * B > 0 && A % B == 0;
}

int get(Vector V) {
    if (V == Vector(0, 0)) return 0;
    swap(V.x, V.y);
    V.y = -V.y;
    vector<Vector> A;
    A.emplace_back(1, 1);
    A.emplace_back(-1, 1);
    A.emplace_back(-1, -1);
    A.emplace_back(1, -1);
    map<int, int> B;
    B[0] = 2;
    B[1] = 8;
    B[2] = 6;
    B[3] = 4;
    for (int i = 0; i < 4; i++) {
        if (check(V, A[i])) {
            return B[i];
        }
    }
    B[0] = 1;
    B[1] = 7;
    B[2] = 5;
    B[3] = 3;
    for (int i = 0; i < 4; i++) {
        if (A[i] % V > 0 && V % A[(i + 1) % 4] > 0) {
            return B[i];
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> A(n, vector<int>(m));
    int a = INT32_MAX, b = INT32_MAX;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> A[i][j];
            if (A[i][j] == 2 || A[i][j] == 6) {
                a = i + j;
            }
            if (A[i][j] == 8 || A[i][j] == 4) {
                b = i - j;
            }
        }
    }

    auto check_C = [&](Point C){
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                Point P(i, j);
                Vector V = C - P;
                if (P != C && get(V) != A[i][j]) {
                    cnt++;
                }
            }
        }
        return cnt == n + m - 2;
    };

    if (a == INT32_MAX) {
        if (check_C(Point(0, 0))) a = 0;
        else a = (n - 1) + (m - 1);
    } else if (b == INT32_MAX) {
        if (check_C(Point(0, m - 1))) b = 0 - (m - 1);
        else b = n - 1;
    }

    int x = (a + b) / 2;
    int y = a - x;
    cout << x + 1 << " " << y + 1 << "\n";

    Point C(x, y);

    A[C.x][C.y] = 0;

    vector<int> ans1;
    vector<int> ans2;
    for (int i = 0; i < n; i++) {
        int cnt = 0;
        for (int j = 0; j < m; j++) {
            Point P(i, j);
            Vector V = C - P;
            cnt += get(V) != A[i][j];
        }
        if (cnt == m - 1) {
            ans1.push_back(i);
        }
    }

    for (int j = 0; j < m; j++) {
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            Point P(i, j);
            Vector V = C - P;
            cnt += get(V) != A[i][j];
        }
        if (cnt == n - 1) {
            ans2.push_back(j);
        }
    }

    vector<vector<int>> B(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            Point P(i, j);
            B[i][j] = get(C - P);
        }
    }

    for (int _i : ans1) {
        for (int _j : ans2) {
            auto D = A;
            for (int j = 0; j < m; j++) {
                Point P(_i, j);
                D[_i][j] = get(C - P);
            }
            for (int i = 0; i < n; i++) {
                Point P(i, _j);
                D[i][_j] = get(C - P);
            }
            if (D == B) {
                cout << _i + 1 << " " << _j + 1 << "\n";
                return 0;
            }
        }
    }
    return 0;
}
