#include "bits/stdc++.h"

#define speedIO  ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define fileIO freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#define vecout(vec, sep, end) for (auto i: vec) { cout << i << sep; } cout << end;
#define forn(n) for (int i = 0; i < n; i++)
#define i128 __int128
const int inf = 1e9;
typedef long long ll;
typedef long double ld;

using namespace std;

class myhash {
    int module = 1e9+7;
    int k = 239;
    vector<int> h;
    vector<int> p;

    int sum(int a, int b) const {
        if (a + b >= module) return a + b - module;
        else return a + b;
    }

    int sub(int a, int b) const {
        if (a - b < 0)
            return a - b + module;
        else
            return a - b;
    }

    int mul(int a, int b) const {
        return 1ll * a * b % module;
    }

public:
    myhash(int n){
        h.resize(n+1);
    }
    myhash (int n, int mod, int w){
        h.resize(n+1);
        module = mod;
        k = w;
    }
    myhash (int n, string str){
        h.resize(n+1);
        p.resize(n+1);

        for (int i = 0; i < str.size(); ++i) {
            h[i + 1] = sum(mul(h[i], k), str[i] % module);
        }
        p[0] = 1;
        for (int i = 0; i < str.size(); ++i) {
            p[i+1] = mul(p[i], k);
        }
    }
    myhash (int n, string str, int mod, int w){
        h.resize(n+1);
        p.resize(n+1);
        module = mod;
        k = w;

        for (int i = 0; i < str.size(); ++i) {
            h[i + 1] = sum(mul(h[i], k), str[i] % module);
        }
        p[0] = 1;
        for (int i = 0; i < str.size(); ++i) {
            p[i+1] = mul(p[i], k);
        }
    }

    void build (string str){
        for (int i = 0; i < str.size(); ++i) {
            h[i + 1] = sum(mul(h[i], k), str[i] % module);
        }
        p[0] = 1;
        for (int i = 0; i < str.size(); ++i) {
            p[i+1] = mul(p[i], k);
        }
    }
    int get(int l, int r) {
        return sub(h[r], mul(h[l], p[r - l]));
    }
};

signed main() {
    speedIO
#ifdef LOCAL
//    fileIO
#endif

    int n;
    cin >> n;

    int length = 0;
    vector<myhash> strs;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;


        length = (int)s.size();
        myhash h(length, s);
        strs.push_back(h);
    }

    for (int i = 0; i < length; ++i) {
        map<int, bool> m;
        for (auto h: strs){
            int val = h.get(0, i+1);
            if (m[val]){
                m.erase(m.find(val));
            }
            else {
                m[val] = true;
            }
        }

        for (auto val: m){
            if (val.second){
                cout << i;
                return 0;
            }
        }
    }
}
