#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#include <iostream>
#include <string>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <fstream>
#include <bitset>
#include <assert.h>
#include <any>
#include <deque>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
#define distr uniform_int_distribution;
#define iters(obj) obj.begin(), obj.end()
#define riters(obj) obj.rbegin(), obj.rend()
ll fast(ll n, vector <ll>& v) {
	vector<ll>pref(n + 1, 0);
	ll ans = 0;
	for (ll i = 0; i < n; i++) {
		pref[i + 1] = v[i];
		pref[i + 1] += pref[i];
		ans += v[i];
	}
	ans = ans / 2 + ans % 2;
	ll l = 0;
	ll r = 1;
	ll sm = v[0];
	ll x = 1e9;
	while (true) { // [l; r]
		if (sm < ans) {
			r++;
			if (r == n + 1) {
				break;
			}
			sm += v[r - 1];
		}
		else {
			x = min(x, r - l);
			sm -= v[l];
			l++;
		}
	}
	assert(x > 0);
	if (x <= 2) {
		return x;
	}
	deque <ll> d;
	for (int i = 0; i < x; ++i) {
		while (!d.empty() && v[d.back()] >= v[i]) {
			d.pop_back();
		}
		d.push_back(i);
	}
	for (ll i = x; i <= n; i++) {
		// [i-x; i)
		// d.front() -     [i-x; i)
		if (pref[i] - pref[i - x] - v[d.front()] >= ans) { // [0; i)
			return x-1;
		}

		// [i+1-x; i+1)
		while (!d.empty() && d.front() <= i - x) {
			d.pop_front();
		}
		if (i == n) break;
		while (!d.empty() && v[d.back()] >= v[i]) {
			d.pop_back();
		}
		d.push_back(i);
	}
	return x;
}
ll slow(ll n, vector <ll>& v) {
	ll half = 0, ans = 1e18;
	vector <ll> pref(n + 1, 0);
	for (int i = 0; i < n; ++i) {
		half += v[i];
		pref[i + 1] = pref[i] + v[i];
	}
	half = (half + 1) / 2;
	for (ll l = 0; l < n; ++l) {
		for (ll r = l + 1; r <= n; ++r) {
			// [l; r)
			if (pref[r] - pref[l] >= half) {
				ans = min(ans, r - l);
			}
			for (int e = l; e < r; ++e) {
				if (pref[r] - pref[l] - v[e] >= half) {
					ans = min(ans, r - l - 1);
				}
			}
		}
	}
	return ans;
}
int main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); cerr.tie(0);
#ifdef STRESS
	for (int seed = 0; ; ++seed) {
		if (seed % 100 == 0) {
			cout << "Checking seed " << seed << endl;
		}
		mt19937 rng(seed);
		ll n = (uniform_int_distribution<ll>(1, 11))(rng);
		vector <ll> v(n);
		uniform_int_distribution<ll> element(0, 100);
		for (auto& i : v) {
			i = element(rng);
		}
		if (fast(n, v) != slow(n, v)) {
			cout << "WA on seed " << seed << endl;
			return 0;
		}
	}
#else
	ll n; cin >> n;
	vector <ll> v(n);
	for (auto& i : v) cin >> i;
	cout << fast(n, v);
#endif
	return 0;
}
