#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <algorithm>
#include <deque>
#include <string>
#include <cctype>


typedef long long ll;
typedef unsigned long long ull;

using namespace std;
const ll INF = 1e18;

class segtree {
 public:
    vector<ll> tree;
    int size;

    explicit segtree(int n) {
        size = 1;
        while (size < n) size *= 2;
        tree.assign(2 * size - 1, 1000000001);
    }

    void set(int i, ll v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = v;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            set(i, v, 2 * x + 1, lx, m);
        } else {
            set(i, v, 2 * x + 2, m, rx);
        }
        tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
    }

    void set(int i, ll v) {
        set(i, v, 0, 0, size);
    }

    ll minimum(int l, int r, int x, int lx, int rx) {
        if (l >= rx || lx >= r) {
            return 1000000001;
        }
        if (l <= lx && rx <= r) {
            return tree[x];
        }
        int m = (lx + rx) / 2;
        ll s1 = minimum(l, r, 2 * x + 1, lx, m);
        ll s2 = minimum(l, r, 2 * x + 2, m, rx);
        return min(s1, s2);
    }

    ll minimum(int l, int r) {
        return minimum(l, r, 0, 0, size);
    }
};


int main(int argc, char *argv[]) {
    cout.precision(10);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n;
    cin >> n;
    segtree tree(n);
    vector<ll> a(n);
    vector<ll> p(n + 1, 0);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        tree.set(i, a[i]);
        p[i + 1] = p[i] + a[i];
    }
    ll k = ceil((double) p[n] / 2);
    vector<ll> ans(n, INF);
    for (ll i = 0; i < n; ++i) {
        ll L = i;
        ll R = n;
        while (R - L > 1) {
            ll M = (R + L) / 2;
            ll s = p[M] - p[i];
            if (s >= k) {
                R = M;
            } else {
                L = M;
            }
        }
        if (p[R] - p[i] >= k) {
            ans[i] = R - i;
        }
    }
    ll res = INF;
    for (ll i = 0; i < n; ++i) {
        res = min(res, ans[i]);
        if (ans[i] >= 3 && ans[i] != INF && p[i + ans[i]] - p[i] - tree.minimum(i, i + ans[i]) >= k) {
            res = min(res, ans[i] - 1);
        }
    }
    cout << res;


    return 0;
}
