import os
import sys
from io import BytesIO, IOBase

_str = str
str = lambda x=b"": x if type(x) is bytes else _str(x).encode()

BUFSIZE = 8192


class FastIO(IOBase):
    newlines = 0

    def __init__(self, file):
        self._fd = file.fileno()
        self.buffer = BytesIO()
        self.writable = "x" in file.mode or "r" not in file.mode
        self.write = self.buffer.write if self.writable else None

    def read(self):
        while True:
            b = os.read(self._fd, max(os.fstat(self._fd).st_size, BUFSIZE))
            if not b:
                break
            ptr = self.buffer.tell()
            self.buffer.seek(0, 2), self.buffer.write(b), self.buffer.seek(ptr)
        self.newlines = 0
        return self.buffer.read()

    def readline(self):
        while self.newlines == 0:
            b = os.read(self._fd, max(os.fstat(self._fd).st_size, BUFSIZE))
            self.newlines = b.count(b"\n") + (not b)
            ptr = self.buffer.tell()
            self.buffer.seek(0, 2), self.buffer.write(b), self.buffer.seek(ptr)
        self.newlines -= 1
        return self.buffer.readline()

    def flush(self):
        if self.writable:
            os.write(self._fd, self.buffer.getvalue())
            self.buffer.truncate(0), self.buffer.seek(0)


class IOWrapper(IOBase):
    def __init__(self, file):
        self.buffer = FastIO(file)
        self.flush = self.buffer.flush
        self.writable = self.buffer.writable
        self.write = lambda s: self.buffer.write(s.encode("ascii"))
        self.read = lambda: self.buffer.read().decode("ascii")
        self.readline = lambda: self.buffer.readline().decode("ascii")


sys.stdin, sys.stdout = IOWrapper(sys.stdin), IOWrapper(sys.stdout)
input = lambda: sys.stdin.readline().rstrip("\r\n")
output = lambda x: sys.stdout.write(x)

n = int(input())
a = list(map(int, input().split()))
t = [0] * 4 * n


def build(u=1, ul=1, ur=n):
    if ul == ur:
        t[u] = a[ul - 1]
        return
    um = (ul + ur) // 2
    build(u * 2, ul, um)
    build(u * 2 + 1, um + 1, ur)
    t[u] = min(t[u * 2], t[u * 2 + 1])


def get(l, r, u=1, ul=1, ur=n):
    if l <= ul and ur <= r:
        return t[u]
    if r < ul or ur < l:
        return float('inf')
    um = (ul + ur) // 2
    resL = get(l, r, u * 2, ul, um)
    resR = get(l, r, u * 2 + 1, um + 1, ur)
    return min(resL, resR)


half = sum(a) /2
l = 0
build()
# print(t)
s = 0
res = float('inf')
for r in range(n):
    s += a[r]
    # print(s)
    while s - get(l+1, r) >= half:
        # print(s, half, res,r,l, get(l,r))
        res = min(res, r - l)
        s -= a[l]
        l += 1
    while s >= half:
        res = min(res, r - l + 1)
        s -= a[l]
        l += 1
print(res)
