#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
#include <cstdio>
using namespace std;

#define sz(x) (int((x).size()))
#define len(x) (int)x.length()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define clr(x) x.clear()
#define uniq(x) x.resize(unique(all(x)) - x.begin());

const long long inf = 1e9;

struct segTree {
  vector<long long> mTree;
  int size;

  void init(long long n) {
    size = 1;
    while(size < n)  {
      size *= 2;
    }
    mTree.assign(2 * size - 1, inf);
  }

  void upd(int u, long long v, int x, int lx, int rx) {
    if(rx - lx == 1) {
      mTree[x] = v;
      return;
    }

    int m = (lx + rx) / 2;
    if(u < m) {
      upd(u, v, 2 * x + 1, lx, m);
    }else {
      upd(u, v, 2 * x + 2, m, rx);
    }
    
    mTree[x] = min(mTree[2 * x + 1], mTree[2 * x + 2]);
  }

  void upd(int u, long long v) {
    upd(u, v, 0, 0, size);
  }

  long long qry (int l, int r, int x, int lx, int rx) {
    if(l >= rx || lx >= r) {
      return inf;
    }
    if(lx >= l && r >= rx) {
      return mTree[x];
    }

    int m = (rx + lx) / 2;

    long long s1 = qry(l, r, 2 * x + 1, lx, m);
    long long s2 = qry(l, r, 2 * x + 2, m, rx);
    return min(s1, s2);
  }

  long long qry(int l, int r) {
    return qry(l, r, 0,0,size);
  }
};

segTree seg;


void solve_() {
  int n; cin >> n;
  vector<long long> a(n + 1), p(n + 1);
  seg.init(n + 1);

  long long s = 0;
  for(int i = 1; i <= n; i++) {
    cin >> a[i], s += a[i];
    p[i] = p[i - 1] + a[i];

    seg.upd(i, a[i]);
  }
  
  s = (s + 1) / 2;

  int pat = n;
  for(int i = 1; i <= n; i++) {
    int ina = i, inb = n, answ = -1;
    while(ina <= inb) {
      int mid = (ina + inb) / 2;
      long long sum = p[mid] - p[i - 1];

      if(sum >= s) {
        answ = mid;
        inb = mid - 1;
      } else {
        ina = mid + 1;
      }
    }

    if(answ == -1) continue;
    int sz = answ - i + 1;
    pat = min(pat, sz);

    long long mini = seg.qry(i, answ + 1);
    long long curr_s = p[answ] - p[i - 1] - mini;
    if(curr_s >= s) {
      pat = min(pat, sz - 1);
    }
  }

  cout << pat << endl;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr); cout.tie(nullptr);

  auto solve = [&](int test_case)-> void {
    while(test_case--) {
      solve_();
    }
  };

  int test_cases = 1;
  solve(test_cases);

  return 0;
}
