#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <tuple>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>

using namespace std;

#define ll long long

const int N = 1e5 + 5;
const int inf = 1e9 + 7;

ll a[N], t[4 * N];
ll pref[N];

void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v] = a[tl];
        return;
    }

    int m = (tl + tr) / 2;
    build(2 * v, tl, m);
    build(2 * v + 1, m + 1, tr);
    t[v] = min(t[2 * v], t[2 * v + 1]);
}

ll query(int v, int tl, int tr, int ql, int qr) {
    if (ql > qr)
        return inf;
    if (tl == ql && tr == qr)
        return t[v];
    int m = (tl + tr) / 2;
    return min(query(2 * v, tl, m, ql, min(m, qr)), query(2 * v + 1, m + 1, tr, max(m + 1, ql), qr));
}

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }

    build(1, 1, n);

    ll d = (pref[n] + 1) / 2;

    int answ = inf;
    for (int k = 1; k <= n; k++) {
        int l = k, r = n;

        while (l <= r) {
            int m = (l + r) / 2;
            if (pref[m] - pref[k - 1] >= d) {
                r = m - 1;
                int q = m - k + 1;
                if (pref[m] - pref[k - 1] - query(1, 1, n, k, m) >= d) {
                    q--;
                }
                answ = min(answ, q);
            }
            else
                l = m + 1;
        }
    }

    cout << answ << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(9);
    cout << fixed;

    int tt = 1;
    //cin >> tt;
    while (tt--)
        solve();

    return 0;
}