#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll inf = 1e14;

struct SegTree
{
    vector <ll> t;
    int n;
    void build(vector <ll>& arr)
    {
        t.resize(arr.size() * 4);
        n = arr.size();
        rec_build(0, n, 0, arr);

    }
    void rec_build(ll l, ll r, ll v, vector <ll>& arr)
    {
        if(r - l == 1)
        {
            t[v] = arr[l];
        }
        else
        {
            int m = (l + r) / 2;
            rec_build(l, m, 2 * v + 1, arr);
            rec_build(m, r, 2 * v + 2, arr);
            t[v] = min(t[2 * v + 1], t[2 * v + 2]);
        }
    }
    int tree_min(ll i, ll j)
    {
        return rec_tree_min(0, n, 0, i, j);
    }
    int rec_tree_min(ll l, ll r, ll v, ll i, ll j)
    {
        if(l == i && r == j)
        {
            return t[v];
        }
        else
        {
            int m = (l + r) / 2;
            if(j <= m)
            {
                return rec_tree_min(l, m, 2 * v + 1, i, j);
            }
            else if(i >= m)
            {
                return rec_tree_min(m, r, 2 * v + 2, i, j);
            }
            else
            {
                return min(rec_tree_min(l, m, 2 * v + 1, i, m), rec_tree_min(m, r, 2 * v + 2, m, j));
            }
        }
    }
};

void solve()
{
    ll n, sum = 0;
    cin >> n;
    vector <ll> v(n);
    for(int i = 0; i < n; i++)
    {
        cin >> v[i];
        sum += v[i];
    }
    sum = sum - sum / 2;
    vector <ll> A(n + 1);
    A[n] = 0;
    for(int i = n - 1; i >= 0; i--)
    {
        A[i] = A[i + 1] + v[i];
    }
    SegTree t;
    t.build(v);
    vector <ll> ans(n);
    ll l, r, m;
    for(int i = 0; i < n; i++)
    {
        if(A[i] < sum)
        {
            ans[i] = inf;
        }
        else
        {
            l = i;
            r = n;
            while(r - l > 1)
            {
                m = (l + r) / 2;
                if(A[i] - A[m] < sum)
                {
                    l = m;
                }
                else
                {
                    r = m;
                }
            }
            if(A[i] - A[r] - t.tree_min(i, r) >= sum)
            {
                ans[i] = r - i - 1;
            }
            else
            {
                ans[i] = r - i;
            }
        }
    }
    /*for(int i = 0; i < n; i++)
    {
        cout << ans[i] << ' ';
    }
    cout << endl;*/
    sort(ans.begin(), ans.end());
    cout << ans[0];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);
    solve();
    return 0;
}
