// -------------------- Includes -------------------- //
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <stdio.h>
#include <cstdlib>
#include <stdlib.h>
#include <array>
#include <string>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <list>
#include <iterator>
#include <numeric>
#include <complex>
#include <tuple>
#include <utility>
#include <cassert>
#include <assert.h>
#include <climits>
#include <limits.h>
#include <ctime>
#include <time.h>
#include <random>
#include <chrono>
#include <fstream>
using namespace std;

// -------------------- Typedefs -------------------- //

typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ld;

// -------------------- Defines -------------------- //

#define pr pair
#define mpr make_pair
#define ff first
#define ss second

#define mset multiset
#define mmap multimap
#define uset unordered_set
#define umap unordered_map
#define umset unordered_multiset
#define ummap unordered_multimap
#define pqueue priority_queue

#define sz(x) (int((x).size()))
#define len(x) (int((x).length()))
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define clr(x) (x).clear()

#define pf push_front
#define pb push_back
#define popf pop_front
#define popb pop_back
#define ft front
#define bk back

#define lb lower_bound
#define ub upper_bound
#define bs binary_search

// -------------------- Constants -------------------- //

const int MAX = int(1e9 + 5);
const ll MAXL = ll(1e18 + 5);
const ll MOD = ll(1e9 + 7);
const ll MOD2 = ll(998244353);

// -------------------- Functions -------------------- //

void fastio()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	return;
}

void precision(int x)
{
	cout.setf(ios::fixed | ios::showpoint);
	cout.precision(x);
	return;
}

ll gcd(ll a, ll b)
{
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

ll lcm(ll a, ll b)
{
	return a / gcd(a, b) * b;
}

bool is_prime(ll a)
{
	if (a == 1) {
		return false;
	}
	for (ll i = 2; i * i <= a; i++) {
		if (a % i == 0) {
			return false;
		}
	}
	return true;
}

bool is_square(ll a)
{
	ll b = ll(sqrt(a));
	return (b * b == a);
}

bool is_cube(ll a)
{
	ll b = ll(cbrt(a));
	return (b * b * b == a);
}

int digit_sum(ll a)
{
	int sum = 0;
	while (a) {
		sum += int(a % 10);
		a /= 10;
	}
	return sum;
}

ll binpow(ll a, int b)
{
	ll ans = 1;
	while (b) {
		if ((b & 1) == 1) {
			ans *= a;
		}
		b >>= 1;
		a *= a;
	}
	return ans;
}

ll binpow_by_mod(ll a, ll b, ll mod)
{
	ll ans = 1;
	while (b) {
		if ((b & 1) == 1) {
			ans *= a;
			ans %= mod;
		}
		b >>= 1;
		a *= a;
		a %= mod;
	}
	return ans;
}

ll factorial(int a)
{
	ll ans = 1;
	for (int i = 2; i <= a; i++) {
		ans *= ll(i);
	}
	return ans;
}

ll factorial_by_mod(int a, ll mod)
{
	ll ans = 1;
	for (int i = 2; i <= a; i++) {
		ans *= ll(i);
		ans %= mod;
	}
	return ans;
}

// -------------------- Solution -------------------- //

const int N = 100005, LG = 20;
ll a[N], pref[N];
int n, lg;

ll t[N][LG];

pr<int, int> h[N];

void bld()
{
	int i, j;

	for (i = 1; i <= n; i++) {
		t[i][0] = a[i];
	}

	int g = 1;

	for (j = 1; j <= lg; j++) {

		for (i = 1; i <= n - (g << 1) + 1; i++) {
			t[i][j] = min(t[i][j - 1], t[i + g][j - 1]);
		}

		g <<= 1;
	}

	return;
}

ll qry(int tl, int tr)
{
	int len = tr - tl + 1;

	int b = h[len].ff, g = h[len].ss;

	return min(t[tl][b], t[tr - g + 1][b]);
}

ll s(int l, int r)
{
	return pref[r] - pref[l - 1];
}

void solve()
{
	int i, j;

	cin >> n;

	lg = 0;
	while ((1 << lg) <= n) lg++;
	lg--;

	ll sum = 0;

	for (i = 1; i <= n; i++) {
		cin >> a[i];
		pref[i] = pref[i - 1] + a[i];
		sum += a[i];
	}

	sum = (sum + 1) / 2;

	bld();

	int ans = MAX;

	int l, r, m;

	for (i = 1; i <= n; i++) {
		l = i;
		r = n;
		while (l < r) {
			m = (l + r) / 2;

			if (s(i, m) < sum) {
				l = m + 1;
			}
			else {
				r = m;
			}
		}

		if (s(i, l) >= sum) ans = min(ans, l - i + 1);

		l = i;
		r = n;
		while (l < r) {
			m = (l + r) / 2;

			if (s(i, m) - qry(i, m) < sum) {
				l = m + 1;
			}
			else {
				r = m;
			}
		}

		if (s(i, l) - qry(i, l) >= sum) ans = min(ans, l - i);
	}

	cout << ans << "\n";

	return;
}

void precalc()
{
	int i, j;

	h[1] = { 0, 1 };

	for (i = 2; i <= 100002; i++) {
		h[i] = h[i - 1];

		if ((h[i].ss << 1) < i) {
			h[i].ff++;
			h[i].ss <<= 1;
		}
	}

	return;
}

int main()
{
	fastio();

	precalc();

	int tests = 1, tc;
	//cin >> tests;
	for (tc = 1; tc <= tests; tc++) {
		solve();
	}

	//cout << db(clock()) / CLOCKS_PER_SEC << endl;

	return 0;
}

/*
	# # # #   # # # #   # # # #   #       #    #       #     #
	   #      #         #     #    #     #    # #      #   #
	   #      # # # #   #     #     #   #    #   #     # #
	   #            #   #     #      # #    # # # #    #   #
	   #      # # # #   # # # #       #    #       #   #     #
*/